import { useRef } from 'react';
export { useRefWithInitialValue };
function useRefWithInitialValue(initialValueFn) {
    const isRefInitializedRef = useRef();
    const ref = useRef();
    if (!isRefInitializedRef.current) {
        isRefInitializedRef.current = true;
        ref.current = initialValueFn();
    }
    const refNonNull = ref;
    return refNonNull;
}
//# sourceMappingURL=useRefWithInitialValue.js.map